                  /*--.          .-"-. 
                 /   ._.        /  ` \
                 \_  (__\       \_v_/
                 //   \\        //   \\
                ((     ))      ((     ))
 --""---""----""---""--
                  |||            |||                                               
   Author's note:  |              |                                                
                                                                                   
   This file is part of work done by Emil Persson, aka Humus.                      
   You're free to use the code in any way you like, modified, unmodified           
   or cut'n'pasted into your own work. But for the good of the whole               
   programming community I will ask you to as long as possible and to the          
   extent you find suitable to follow these points:                                
    * If you use this file and it's contents unmodified, please leave this note.   
    * If you use a major part of the file in your app, please credit the author(s) 
      in one way or the other as you find suitable, for instance a small notice    
      in the readme file may do, or perhaps a link to the authors site.            
    * Share your work and ideas too as much as you can.                            
     _______                                                                       
   /` _____ `\;,    Humus                                                          
  (__(^===^)__)';,  emiper-8@student.luth.se                         ___           
    /  :::  \   ,;  ICQ #47010716                                  /^   ^\         
   |   :::   | ,;'                                                (     )        
 '._______.'`--oOo--(_)--oOo--*/

#ifndef _FRAMEWORK_H_
#define _FRAMEWORK_H_

#include "Platform.h"

#if defined(WIN32)

	#include "../Framework/Windows/OpenGLApp.h"


	#define RED_BITS     WGL_RED_BITS_ARB
	#define GREEN_BITS   WGL_GREEN_BITS_ARB
	#define BLUE_BITS    WGL_BLUE_BITS_ARB
	#define ALPHA_BITS   WGL_ALPHA_BITS_ARB
	#define DEPTH_BITS   WGL_DEPTH_BITS_ARB
	#define STENCIL_BITS WGL_STENCIL_BITS_ARB

	#define DECLARE_MAIN_APP(MainAppClass) MainAppClass mainApp;

	#define ALERT(str, str2) MessageBox(m_pMainWnd->GetSafeHwnd(), str, str2, MB_OK | MB_ICONERROR);

#elif defined(LINUX)

	#include "../Framework/Linux/OpenGLApp.h"

	#define RED_BITS     GLX_RED_SIZE
	#define GREEN_BITS   GLX_GREEN_SIZE
	#define BLUE_BITS    GLX_BLUE_SIZE
	#define ALPHA_BITS   GLX_ALPHA_SIZE
	#define DEPTH_BITS   GLX_DEPTH_SIZE
	#define STENCIL_BITS GLX_STENCIL_SIZE

	#define DECLARE_MAIN_APP(MainAppClass) MainAppClass _mainApp; OpenGLApp *mainApp = &_mainApp;

	#include <stdio.h>
	#define ALERT(str, str2) printf("[%s]\n%s\n", (const char *) (str), (const char *) (str2));

#endif




#endif // _FRAMEWORK_H_
