                  /*--.          .-"-. 
                 /   ._.        /  ` \
                 \_  (__\       \_v_/
                 //   \\        //   \\
                ((     ))      ((     ))
 --""---""----""---""--
                  |||            |||                                               
   Author's note:  |              |                                                
                                                                                   
   This file is part of work done by Emil Persson, aka Humus.                      
   You're free to use the code in any way you like, modified, unmodified           
   or cut'n'pasted into your own work. But for the good of the whole               
   programming community I will ask you to as long as possible and to the          
   extent you find suitable to follow these points:                                
    * If you use this file and it's contents unmodified, please leave this note.   
    * If you use a major part of the file in your app, please credit the author(s) 
      in one way or the other as you find suitable, for instance a small notice    
      in the readme file may do, or perhaps a link to the authors site.            
    * Share your work and ideas too as much as you can.                            
     _______                                                                       
   /` _____ `\;,    Humus                                                          
  (__(^===^)__)';,  emiper-8@student.luth.se                         ___           
    /  :::  \   ,;  ICQ #47010716                                  /^   ^\         
   |   :::   | ,;'                                                (     )        
 '._______.'`--oOo--(_)--oOo--*/


#ifndef _PLANE_H_
#define _PLANE_H_

#include "Vertex.h"

enum RELATION {BACK = -1, PLANAR = 0, FRONT = 1, CUTS = 2};

struct Plane {
	Vertex normal;
	float offset;

	Plane(){}
	Plane(const Vertex &Normal, const float Offset);
	Plane(const float a, const float b, const float c, const float d);
	Plane(const Vertex &v0, const Vertex &v1, const Vertex &v2);

	void normalize();
	float distance(const Vertex &v) const;
	float getPlaneHitInterpolationConstant(const Vertex &v0, const Vertex &v1) const;
	RELATION getVertexRelation(const Vertex &v, float planarDiff = 0.03f) const;
};

#endif
