                  /*--.          .-"-. 
                 /   ._.        /  ` \
                 \_  (__\       \_v_/
                 //   \\        //   \\
                ((     ))      ((     ))
 --""---""----""---""--
                  |||            |||                                               
   Authors note:   |              |                                                
                                                                                   
   This file is part of work done by Emil Persson, aka Humus.                      
   You're free to use the code in any way you like, modified, unmodified           
   or cut'n'pasted into your own work. But for the good of the whole               
   programming community I will ask you to as long as possible and to the          
   extent you find suitable to follow these points:                                
    * If you use this file and it's contents unmodified, please leave this note.   
    * If you use a major part of the file in your app, please credit the author(s) 
      in one way or the other as you find suitable, for instance a small notice    
      in the readme file may do, or perhaps a link to the authors site.            
    * Share your work and ideas too as much as you can.                            
     _______                                                                       
   /` _____ `\;,    Humus                                                          
  (__(^===^)__)';,  emiper-8@student.luth.se                         ___           
    /  :::  \   ,;  ICQ #47010716                                  /^   ^\         
   |   :::   | ,;'                                                (     )        
 '._______.'`--oOo--(_)--oOo--*/


#include "OpenGLPolygon.h"


void OpenGLPolygon::draw(Renderer *renderer){
	if (!(flags & PF_PORTAL)){
		renderer->setTextures(material->textures[0]);
		if (flags & PF_TRANSLUCENT) renderer->setBlending(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	}
	renderer->apply();
	
	glBegin(GL_TRIANGLE_FAN);
	for (unsigned int i = 0; i < nVertices; i++){
		Vertex v = vertices[i] - origin;
		
		glTexCoord2f(v * s * scaleS, v * t * scaleT);
		
		glVertex3fv(vertices[i]);
	}
	glEnd();
}

class Polygon *OpenGLPolygon::create(const int size) const {
	return new OpenGLPolygon(size);
}









class Polygon *openGLPolyCreator(const int size){
	return new OpenGLPolygon(size);
}
