                  /*--.          .-"-. 
                 /   ._.        /  ` \
                 \_  (__\       \_v_/
                 //   \\        //   \\
                ((     ))      ((     ))
 --""---""----""---""--
                  |||            |||                                               
   Author's note:  |              |                                                
                                                                                   
   This file is part of work done by Emil Persson, aka Humus.                      
   You're free to use the code in any way you like, modified, unmodified           
   or cut'n'pasted into your own work. But for the good of the whole               
   programming community I will ask you to as long as possible and to the          
   extent you find suitable to follow these points:                                
    * If you use this file and it's contents unmodified, please leave this note.   
    * If you use a major part of the file in your app, please credit the author(s) 
      in one way or the other as you find suitable, for instance a small notice    
      in the readme file may do, or perhaps a link to the authors site.            
    * Share your work and ideas too as much as you can.                            
     _______                                                                       
   /` _____ `\;,    Humus                                                          
  (__(^===^)__)';,  emiper-8@student.luth.se                         ___           
    /  :::  \   ,;  ICQ #47010716                                  /^   ^\         
   |   :::   | ,;'                                                (     )        
 '._______.'`--oOo--(_)--oOo--*/

#ifndef _TOKENIZER_H_
#define _TOKENIZER_H_

typedef bool (*BOOLFUNC)(const char ch);

bool isDelimiter(const char ch);
bool isNumeric(const char ch);
bool isAlphabetical(const char ch);

class Tokenizer {
private:
	char *str;
	unsigned int length;
	unsigned int start, end;

public:
	Tokenizer();
	~Tokenizer();

	void setString(const char *string);
	bool setFile(const char *fileName);
	void reset();
	bool next(char *buffer, BOOLFUNC isAlpha = isAlphabetical);
	bool nextAfterToken(char *buffer, char *token);
	bool getAllRight(char *buffer);

};

#endif // _TOKENIZER_H_
